from bs4 import BeautifulSoup

from ..twosteps_extractor import TwoStepsExtractorNoPause


# A class dedicated to get events from Raymond Bar
# URL: https://www.raymondbar.net/
class CExtractor(TwoStepsExtractorNoPause):
    def __init__(self):
        super().__init__()

    def build_event_url_list(self, content, infuture_days=180):
        soup = BeautifulSoup(content, "html.parser")

        links = soup.select(".showsList .showMore")
        if links:
            for lk in links:
                self.add_event_url(lk["href"])

    def add_event_from_content(
        self,
        event_content,
        event_url,
        url_human=None,
        default_values=None,
        published=False,
    ):
        soup = BeautifulSoup(event_content, "html.parser")

        title = soup.select_one(".showDesc h4 a.summary").text
        start_day = soup.select_one(".showDate .value-title")
        start_time = "warning"

        if start_day is not None:
            start_day = start_day["title"]
            if start_day is not None:
                start_day = start_day.split("T")[0]

        description = soup.select_one(".showDetails.description").text
        image = soup.select(".showDetails.description img")
        if image is not None and len(image) > 0:
            image_alt = image[-1]["alt"]
            image = image[-1]["src"]
        else:
            image = None
            image_alt = None

        self.add_event_with_props(
            default_values,
            event_url,
            title,
            None,
            start_day,
            None,
            description,
            [],
            recurrences=None,
            uuids=[event_url],
            url_human=event_url,
            start_time=start_time,
            end_day=None,
            end_time=None,
            published=published,
            image=image,
            image_alt=image_alt,
        )
